libstdc++: std::unique_ptr< _Tp[], _Dp > Class Template Reference

libstdc++

std::unique_ptr< _Tp[], _Dp > Class Template Reference
Utilities » Memory » Pointer Abstractions

`#include <memory>`

## Public Types
template<typename _Up>
using | __safe_conversion_raw
template<typename _Up, typename _Ep, typename _UPtr = unique_ptr<_Up, _Ep>, typename _UP_pointer = typename _UPtr::pointer, typename _UP_element_type = typename _UPtr::element_type>
using | __safe_conversion_up
using | deleter_type
using | element_type
using | pointer

## Public Member Functions
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr () noexcept
template<typename _Up, typename _Vp = _Dp, typename = _DeleterConstraint<_Vp>, typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
constexpr | unique_ptr (_Up __p) noexcept
template<typename _Up, typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_move_constructible<_Del>>>
constexpr | unique_ptr (_Up __p, __enable_if_t<!is_lvalue_reference< _Del >::value, _Del && > __d) noexcept
template<typename _Up, typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_copy_constructible<_Del>>>
constexpr | unique_ptr (_Up __p, const deleter_type &__d) noexcept
template<typename _Up, typename _Del = deleter_type, typename _DelUnref = typename remove_reference<_Del>::type, typename = _Require<__safe_conversion_raw<_Up>>>
| unique_ptr (_Up, __enable_if_t< is_lvalue_reference< _Del >::value, _DelUnref && >)=delete
| unique_ptr (const unique_ptr &)=delete
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr (nullptr_t) noexcept
| unique_ptr (unique_ptr &&)=default
template<typename _Up, typename _Ep, typename = _Require< __safe_conversion_up<_Up, _Ep>, __conditional_t<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>>>
constexpr | unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
constexpr | ~unique_ptr ()
constexpr pointer | get () const noexcept
constexpr const deleter_type & | get_deleter () const noexcept
constexpr deleter_type & | get_deleter () noexcept
constexpr | operator bool () const noexcept
constexpr add_lvalue_reference< element_type >::type | operator* () const noexcept(noexcept(*std::declval< pointer >()))
constexpr pointer | operator-> () const noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
constexpr unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (unique_ptr &&)=default
template<typename _Up, typename _Ep>
constexpr enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
constexpr std::add_lvalue_reference< element_type >::type | operator[] (size_t __i) const
constexpr pointer | release () noexcept
template<typename _Up, typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>
constexpr void | reset (_Up __p) noexcept
constexpr void | reset (nullptr_t=nullptr) noexcept
constexpr void | swap (unique_ptr &__u) noexcept

## Friends
template<typename, typename, typename...>
class | inout_ptr_t
template<typename, typename, typename...>
class | out_ptr_t

## Related Symbols
(Note that these are not member symbols.)
basic_ostream< _CharT, _Traits > & | operator<< (basic_ostream< _CharT, _Traits > &__os, const unique_ptr< _Tp, _Dp > &__p)
constexpr enable_if< __is_swappable< _Dp >::value >::type | swap (unique_ptr< _Tp, _Dp > &__x, unique_ptr< _Tp, _Dp > &__y) noexcept

## Detailed Description

template<typename _Tp, typename _Dp>
class std::unique_ptr< _Tp[], _Dp >

A move-only smart pointer that manages unique ownership of an array.

Since
  C++11

Definition at line 545 of file unique_ptr.h.

## Member Typedef Documentation

## ◆ __safe_conversion_raw

template<typename _Tp, typename _Dp>
template<typename _Up>

using std::unique_ptr< _Tp[], _Dp >::__safe_conversion_raw

Definition at line 578 of file unique_ptr.h.

## ◆ __safe_conversion_up

template<typename _Tp, typename _Dp>
template<typename _Up, typename _Ep, typename _UPtr = unique_ptr<_Up, _Ep>, typename _UP_pointer = typename _UPtr::pointer, typename _UP_element_type = typename _UPtr::element_type>

using std::unique_ptr< _Tp[], _Dp >::__safe_conversion_up

Definition at line 569 of file unique_ptr.h.

## ◆ deleter_type

template<typename _Tp, typename _Dp>

using std::unique_ptr< _Tp[], _Dp >::deleter_type

Definition at line 561 of file unique_ptr.h.

## ◆ element_type

template<typename _Tp, typename _Dp>

using std::unique_ptr< _Tp[], _Dp >::element_type

Definition at line 560 of file unique_ptr.h.

## ◆ pointer

template<typename _Tp, typename _Dp>

using std::unique_ptr< _Tp[], _Dp >::pointer

Definition at line 559 of file unique_ptr.h.

## Constructor & Destructor Documentation

## ◆ unique_ptr() [1/7]

template<typename _Tp, typename _Dp>
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( |  | ) |
| inlineconstexprnoexcept

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 594 of file unique_ptr.h.

References unique_ptr().

Referenced by unique_ptr(), unique_ptr(), unique_ptr(), unique_ptr(), unique_ptr(), unique_ptr(), ~unique_ptr(), operator=(), operator=(), operator=(), and swap().

## ◆ unique_ptr() [2/7]

template<typename _Tp, typename _Dp>
template<typename _Up, typename _Vp = _Dp, typename = _DeleterConstraint<_Vp>, typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p | ) |
| inlineexplicitconstexprnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`

The deleter will be value-initialized.

Definition at line 612 of file unique_ptr.h.

References unique_ptr().

## ◆ unique_ptr() [3/7]

template<typename _Tp, typename _Dp>
template<typename _Up, typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_copy_constructible<_Del>>>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p,
|  | const deleter_type & | __d )
| inlineconstexprnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `__d`

Definition at line 628 of file unique_ptr.h.

References unique_ptr().

## ◆ unique_ptr() [4/7]

template<typename _Tp, typename _Dp>
template<typename _Up, typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_move_constructible<_Del>>>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p,
|  | __enable_if_t<!is_lvalue_reference< _Del >::value, _Del && > | __d )
| inlineconstexprnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `std::move(__d)`

Definition at line 643 of file unique_ptr.h.

References unique_ptr(), and std::move().

## ◆ unique_ptr() [5/7]

template<typename _Tp, typename _Dp>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | unique_ptr< _Tp[], _Dp > && |  | ) |
| default

Move constructor.

References unique_ptr().

## ◆ unique_ptr() [6/7]

template<typename _Tp, typename _Dp>
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | nullptr_t |  | ) |
| inlineconstexprnoexcept

Creates a unique_ptr that owns nothing.

Definition at line 661 of file unique_ptr.h.

References unique_ptr().

## ◆ unique_ptr() [7/7]

template<typename _Tp, typename _Dp>
template<typename _Up, typename _Ep, typename = _Require< __safe_conversion_up<_Up, _Ep>, __conditional_t<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>>>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | unique_ptr< _Up, _Ep > && | __u | ) |
| inlineconstexprnoexcept

Definition at line 671 of file unique_ptr.h.

## ◆ ~unique_ptr()

template<typename _Tp, typename _Dp>

std::unique_ptr< _Tp[], _Dp >::~unique_ptr | ( |  | ) |
| inlineconstexpr

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 679 of file unique_ptr.h.

References unique_ptr(), and get_deleter().

## Member Function Documentation

## ◆ get()

template<typename _Tp, typename _Dp>

pointer std::unique_ptr< _Tp[], _Dp >::get | ( |  | ) | const
| inlineconstexprnoexcept

Return the stored pointer.

Definition at line 740 of file unique_ptr.h.

References get().

Referenced by get(), operator bool(), and operator[]().

## ◆ get_deleter() [1/2]

template<typename _Tp, typename _Dp>

const deleter_type & std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) | const
| inlineconstexprnoexcept

Return a reference to the stored deleter.

Definition at line 752 of file unique_ptr.h.

References get_deleter().

## ◆ get_deleter() [2/2]

template<typename _Tp, typename _Dp>

deleter_type & std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) |
| inlineconstexprnoexcept

Return a reference to the stored deleter.

Definition at line 746 of file unique_ptr.h.

References get_deleter().

Referenced by ~unique_ptr(), get_deleter(), get_deleter(), and operator=().

## ◆ operator bool()

template<typename _Tp, typename _Dp>

std::unique_ptr< _Tp[], _Dp >::operator bool | ( |  | ) | const
| inlineexplicitconstexprnoexcept

Return `true` if the stored pointer is not null.

Definition at line 757 of file unique_ptr.h.

References get().

## ◆ operator*()

add_lvalue_reference< element_type >::type std::unique_ptr< _Tp, _Dp >::operator* | ( |  | ) | const
| inlineconstexprnoexcept

Dereference the stored pointer.

Definition at line 445 of file unique_ptr.h.

## ◆ operator->()

pointer std::unique_ptr< _Tp, _Dp >::operator-> | ( |  | ) | const
| inlineconstexprnoexcept

Return the stored pointer.

Definition at line 462 of file unique_ptr.h.

## ◆ operator=() [1/3]

template<typename _Tp, typename _Dp>

unique_ptr & std::unique_ptr< _Tp[], _Dp >::operator= | ( | nullptr_t |  | ) |
| inlineconstexprnoexcept

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 720 of file unique_ptr.h.

References unique_ptr(), operator=(), and reset().

## ◆ operator=() [2/3]

template<typename _Tp, typename _Dp>

unique_ptr & std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Tp[], _Dp > && |  | ) |
| default

Move assignment operator.

Invokes the deleter if this object owns a pointer.

References unique_ptr(), and operator=().

Referenced by operator=(), operator=(), and operator=().

## ◆ operator=() [3/3]

template<typename _Tp, typename _Dp>
template<typename _Up, typename _Ep>

enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Up, _Ep > && | __u | ) |
| inlineconstexprnoexcept

Assignment from another type.

Parameters

  __u | The object to transfer ownership from, which owns a convertible pointer to an array object.

Invokes the deleter if this object owns a pointer.

Definition at line 710 of file unique_ptr.h.

References unique_ptr(), std::forward(), get_deleter(), operator=(), and reset().

## ◆ operator[]()

template<typename _Tp, typename _Dp>

std::add_lvalue_reference< element_type >::type std::unique_ptr< _Tp[], _Dp >::operator[] | ( | size_t | __i | ) | const
| inlineconstexpr

Access an element of owned array.

Definition at line 731 of file unique_ptr.h.

References get(), and operator[]().

Referenced by operator[]().

## ◆ release()

template<typename _Tp, typename _Dp>

pointer std::unique_ptr< _Tp[], _Dp >::release | ( |  | ) |
| inlineconstexprnoexcept

Release ownership of any stored pointer.

Definition at line 765 of file unique_ptr.h.

References release().

Referenced by release().

## ◆ reset() [1/2]

template<typename _Tp, typename _Dp>
template<typename _Up, typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>

void std::unique_ptr< _Tp[], _Dp >::reset | ( | _Up | __p | ) |
| inlineconstexprnoexcept

Replace the stored pointer.

Parameters

  __p | The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 788 of file unique_ptr.h.

References std::move(), and reset().

Referenced by operator=(), operator=(), and reset().

## ◆ reset() [2/2]

template<typename _Tp, typename _Dp>

void std::unique_ptr< _Tp[], _Dp >::reset | ( | nullptr_t | = nullptr | ) |
| inlineconstexprnoexcept

Definition at line 792 of file unique_ptr.h.

## ◆ swap()

template<typename _Tp, typename _Dp>

void std::unique_ptr< _Tp[], _Dp >::swap | ( | unique_ptr< _Tp[], _Dp > & | __u | ) |
| inlineconstexprnoexcept

Exchange the pointer and deleter with another object.

Definition at line 798 of file unique_ptr.h.

References unique_ptr(), and swap().

Referenced by swap().

## Friends And Related Symbol Documentation

## ◆ inout_ptr_t

template<typename _Tp, typename _Dp>
template<typename, typename, typename...>

friend class inout_ptr_t
| friend

Definition at line 811 of file unique_ptr.h.

## ◆ operator<<()

basic_ostream< _CharT, _Traits > & operator<< | ( | basic_ostream< _CharT, _Traits > & | __os,
|  | const unique_ptr< _Tp, _Dp > & | __p )
| related

Stream output operator for unique_ptr.

Since
  C++20

Definition at line 1012 of file unique_ptr.h.

## ◆ out_ptr_t

template<typename _Tp, typename _Dp>
template<typename, typename, typename...>

friend class out_ptr_t
| friend

Definition at line 810 of file unique_ptr.h.

## ◆ swap()

enable_if< __is_swappable< _Dp >::value >::type swap | ( | unique_ptr< _Tp, _Dp > & | __x,
|  | unique_ptr< _Tp, _Dp > & | __y )
| related

Swap overload for unique_ptr.

Definition at line 829 of file unique_ptr.h.

The documentation for this class was generated from the following files:

- unique_ptr.h
- auto_ptr.h